


/*
 * Astroblast 2000 
 * Copyright (C) 2000 David Piott
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _ab2t_
#define _ab2t_


#include <stdio.h>
#include <stdlib.h>
#include "SDL.h"


int MPF=10;
int MPU=10;
int MPD=10;
int MPM=10;
#define MPS 200
#define P_SPEED 20
#define F_SPEED 30
#define MAXFRAMES 12
int WIDTH=790;
int HEIGHT=520;
int BPP=32;
int GROUND=160;
int STARTX=160;
int STARTY=150;
int MARGIN=20;
int DEBUG=0;
int CHEAT=0;
int CHEAT2=0;
int CRUSH=0;
int _2D=0;

enum {LEFT, UPLEFT, UP, UPRIGHT, RIGHT, DOWNRIGHT, DOWN, DOWNLEFT};

enum {LMETEO,BMETEO,SEEKER,STAR,BULLET,PLAYER};

int Score, GScore, GLives;
int Time;
int Lives;
int Firing;
int CurrentFrame;
int Play;
int Level;
int NewLevel;
SDL_Surface *Screen;
SDL_Surface *Sprite[MAXFRAMES];

typedef struct Animation
{
	SDL_Surface *frame[4];
	
};

typedef struct Thing
{
	Thing *prev, *next;
	Animation *image;
	int health, type;
	int dir, speed, x, y;
	void (*update)(Thing*);
	void (*move)(Thing*);
	void (*draw)(Thing*);
	
};

Thing *Player;
Thing *Death;
char* itoa(int value);    /* integer to array */
int CheckContact(Thing *a, Thing *b);	
void DestroyThing(Thing *dead);
Thing* CreateLMeteo(Thing* creator, int dir, int speed, int x, int y);
Thing* CreateBMeteo(Thing* creator, int dir, int speed, int x, int y);
Thing* CreateStar(Thing* creator, int dir, int speed, int x, int y);
Thing* CreateSeeker(Thing* creator, int dir, int speed, int x, int y);
Thing* CreateBullet(Thing* creator, int dir, int speed, int x, int y);
void UpdateLMeteo(Thing *t);
void UpdateBMeteo(Thing *t);
void UpdateStar(Thing *t);
void UpdateSeeker(Thing *t);
void UpdateBullet(Thing *t);
void UpdatePlayer(Thing *t);
void KillAll(void);
void Move(Thing *t);
void Draw(Thing *t);
Thing* GotoStart(Thing* list);
void MainLoop(void);
void InitGame(void);
void DrawBackground(void);
void MeteoGenerator(void);
int LoadSprites(void) ;


#endif
